=== debian/changelog ===
capnproto (1.0.1-4) unstable; urgency=medium

  * Add patch for FTBFS on 32-bit ARM after the time_t 64 transition.
    Thank you to Arnd Bergmann, Wookey, Tom Lee, and Andrey Rakhmatullin
    for their for help resolving this bug.  (Closes: #1067916)

 -- tony mancill <tmancill@debian.org>  Mon, 15 Apr 2024 22:09:51 -0700

capnproto (1.0.1-3) unstable; urgency=medium

  * Add upstream patch to resolve CVE-2023-48230 (Closes: #1056615)
    Debian's patched 1.0.1 is equivalent to upstream 1.0.1.1.

 -- tony mancill <tmancill@debian.org>  Fri, 24 Nov 2023 21:14:08 -0800

capnproto (1.0.1-2) unstable; urgency=medium

  * Upload version 1.0.1 to unstable
    Transition bug #1053765

 -- tony mancill <tmancill@debian.org>  Tue, 10 Oct 2023 20:49:02 -0700

capnproto (1.0.1-1) experimental; urgency=medium

  * New upstream version 1.0.1 (Closes: #1041973)
  * Update debian/gbp.conf for upload to experimental
  * Refresh patches for upstream release 1.0.1
  * Freshen debian/copyright

 -- tony mancill <tmancill@debian.org>  Fri, 06 Oct 2023 19:44:29 -0700

capnproto (0.9.2-4) unstable; urgency=medium

  * Add patch for LFS support on 32-bit systems (Closes: #1051704)

 -- tony mancill <tmancill@debian.org>  Sat, 16 Sep 2023 11:11:47 -0700
