=== debian/changelog ===
capnproto (1.1.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Bump CMAKE_MINIMUM_REQUIRED version to 3.5 to fix autopkgtests with CMake
    4. (Closes: #1118577)

 -- James McCoy <jamessan@debian.org>  Tue, 11 Nov 2025 07:19:43 -0500

capnproto (1.1.0-2) unstable; urgency=medium

  * Upload version 1.1.0 to unstable
    Transition bug #1091963

 -- tony mancill <tmancill@debian.org>  Sat, 11 Jan 2025 09:52:35 -0800

capnproto (1.1.0-1) experimental; urgency=medium

  * New upstream release 1.1.0
  * Upload to experimental
  * Freshen patches for new upstream release and add missing DEP-3 headers
  * Freshen years in debian/copyright and remove superfluous file patterns
  * Bump Standards-Version to 4.7.0

 -- tony mancill <tmancill@debian.org>  Mon, 30 Dec 2024 10:39:33 -0800
