=== debian/control ===
--- 
+++ 
@@ -13,13 +13,13 @@
  xsltproc,
  zlib1g-dev,
  ca-certificates
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://capnproto.org/
 Vcs-Git: https://github.com/thomaslee/capnproto-debian.git -b debian/master
 Vcs-Browser: https://github.com/thomaslee/capnproto-debian
 Rules-Requires-Root: no
 
-Package: libcapnp-1.0.1
+Package: libcapnp-1.1.0
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -41,7 +41,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: ${misc:Depends}, libcapnp-1.0.1 (= ${binary:Version}), libssl-dev
+Depends: ${misc:Depends}, libcapnp-1.1.0 (= ${binary:Version}), libssl-dev
 Description: Cap'n Proto C++ library (development files)
  Similar to Protocol Buffers, Cap'n Proto is an efficient means of
  serializing structured data to be transferred across a network or
@@ -60,7 +60,7 @@
 Architecture: any
 Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends},
- libcapnp-1.0.1 (= ${binary:Version})
+ libcapnp-1.1.0 (= ${binary:Version})
 Description: tool for working with the Cap'n Proto data interchange format
  Similar to Protocol Buffers, Cap'n Proto is an efficient means of
  serializing structured data to be transferred across a network or
