=== debian/tests/control ===
Tests: cli-tests, build-tests, serde-tests, atomic-tests
Depends: @, shunit2, bash, g++, pkg-config, cmake
