=== debian/watch ===
version=4
https://capnproto.org/install.html https?://capnproto.org/capnproto-c\+\+-(.+)\.tar\.gz
